/*


    Evolute version 0.7
    Copyright (C) 2010 Antti Vainio

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.


*/

//          staget.cpp

#include <math.h>
#include "global.hpp"

//karttavalikko
void staget() {
     bool pois1 = false; //aloita poistuminen
     bool pois2 = false; //ulos loopista!
     float kasautuminen = 0;
     float nappikasautuminen = 0;
     bool napit = false;
     short int valinta = 0;
     short int prewvalinta = 0;
     short int mappivalinta = -10;
     bool progress[10];
     short progressmaara = 0;
     
     //luetaan progress
     tiedosto = fopen("maps/Stages/progress.dat", "r");
     if(tiedosto == NULL) {
                 luoprogressf(0);
                 tiedosto = fopen("maps/Stages/progress.dat", "r");
     }
     if(tiedosto != NULL) {
                 char c;
                 for(int i=0;i<10;i++) {
                         c = getc(tiedosto);
                         if(c == '0') progress[i] = false;
                         else {
                              progress[i] = true;
                              progressmaara++;
                              if(i == 4) progressmaara++;
                         }
                 }
                 fclose(tiedosto);
     }
     
     while(!pois2) {
                 alkuaika = SDL_GetTicks();
                 
                 //hiiri ja nappulat
                 SDL_GetMouseState(&hiirix,&hiiriy);
                 pelaajaninputit = SDL_GetKeyState(NULL);
                 if(SDL_GetMouseState(NULL, NULL)&SDL_BUTTON(1)) hiiriekanappi = true;
                 else hiiriekanappi = false;
                 
                 //lasketaan kasautuminen
                 if(!pois1) kasautuminen++;
                 else if(menuvalinta != 100) kasautuminen--;
                 else kasautuminen-= 0.25;
                 if(pois1 && menuvalinta != 100 && kasautuminen < 1) pois2 = true;
                 if(pois1 && menuvalinta == 100 && kasautuminen < 0.25) pois2 = true;
                 if(kasautuminen < 20) SDL_SetAlpha(valkoinenfade, SDL_SRCALPHA, int(round(255 - kasautuminen * 12.75)));
                 else SDL_SetAlpha(valkoinenfade, SDL_SRCALPHA, 0);
                 if(napit) nappikasautuminen++;
                 
                 //testataan onko hiiri nappien päällä
                 if(kasautuminen > 20 && nappikasautuminen > 10 && hiiriy > 500 && hiiriy < 550) {
                           if(hiirix > 338 && hiirix < 463) valinta = 100; //suoraan peliin
                           else valinta = 0;
                 }
                 else valinta = 0;
                 if(kasautuminen > 20 && hiirix < 150 && hiiriy > 550) valinta = -1; //back-nappi
                 
                 //testataan irroitettiinko hiiri napin päällä
                 if(kasautuminen > 20 && valinta != 0 && hiiriprewekanappi && !hiiriekanappi) {
                           if(valinta == -1) {
                                      pois1 = true;
                                      menuvalinta = 1;
                                      if(kasautuminen > 20) kasautuminen = 20;
                           }
                           else {
                                      menuvalinta = valinta;
                                      if(menuvalinta == 100) {
                                                     pois1 = true;
                                                     kasautuminen = 20;
                                                     Mix_FadeOutMusic(2000);
                                      }
                                      else if(menuvalinta == 2) piirtokohta = tempruutu;
                           }
                           soitaaani(nappi2); //ääni
                 }
                 
                 //nappiäänet
                 if(hiiriekanappi && !hiiriprewekanappi && valinta != 0) soitaaani(nappi1);
                 else if(valinta != prewvalinta && valinta != 0) {
                            if(hiiriekanappi) soitaaani(nappi1);
                            else soitaaani(nappion);
                 }
                 
                 //hiiren nappi painettiin
                 if(hiiriekanappi && !hiiriprewekanappi && kasautuminen > 20) {
                                  //testataan onko hiiri nappien päällä
                                  if(hiiriy > 163 && hiiriy < 238) {
                                            for(int i=0;i<5;i++) {
                                                    if(hiirix > 100 + 125 * i && hiirix < 200 + 125 * i && progressmaara >= i) {
                                                              soitaaani(nappi2); //ääni
                                                              mappivalinta = i + 1;
                                                              napit = true;
                                                    }
                                            }
                                  }
                                  if(hiiriy > 263 && hiiriy < 338) {
                                            for(int i=0;i<5;i++) {
                                                    if(hiirix > 100 + 125 * i && hiirix < 200 + 125 * i && progressmaara >= i + 5) {
                                                              soitaaani(nappi2); //ääni
                                                              mappivalinta = i + 6;
                                                              napit = true;
                                                    }
                                            }
                                  }
                                  sprintf(viesti, "Stage%i", mappivalinta);
                                  asetakartta(viesti);
                 }
                 
                 if(menuvalinta != 100) {
                                if(pelaajaninputit[SDLK_ESCAPE]) {//ESC-nappi
                                                  if(menuvalinta != 1) soitaaani(nappi2); //ääni
                                                  pois1 = true;
                                                  menuvalinta = 1;
                                                  if(kasautuminen > 20) kasautuminen = 20;
                                }
                                else if(pelaajaninputit[SDLK_RETURN] && kasautuminen > 20 && nappikasautuminen > 10) { //ENTER-nappi
                                                  soitaaani(nappi2); //ääni
                                                  pois1 = true;
                                                  menuvalinta = 100; //peliin
                                                  kasautuminen = 20;
                                                  Mix_FadeOutMusic(2000);
                                }
                 }
                 
                      //Piirretään kaikki
                 piirrakuva2(menutausta, 0, 0);
                 if(piirtokohta == ruutu) piirrakuva(otsikko, 400, 50);
                 //vanhat napit
                 if(kasautuminen < 20 && menuvalinta != 100) {
                                 piirrakuva(menunappitutorial1, 400 - 30 * kasautuminen, 175);
                                 piirrakuva(menunappistages2[0], 400 - 30 * kasautuminen, 275);
                                 piirrakuva(menunappisurvival1, 400 - 30 * kasautuminen, 375);
                                 piirrakuva(menunappicustommap1, 400 - 30 * kasautuminen, 475);
                 }
                 //napit
                 if(menuvalinta != 100) {
                                if(valinta == -1 && hiiriprewekanappi) piirrakuva(nappitakaisin[2], 75, 575);
                                else if(valinta == -1) piirrakuva(nappitakaisin[1], 75, 575);
                                else piirrakuva(nappitakaisin[0], 75, 575);
                                
                                //mappinapit
                                if(kasautuminen < 20) {
                                                if(mappivalinta <= 5) piirrakuva(mappinappi0, 725 + 125 * mappivalinta - 35 * kasautuminen, 200);
                                                else piirrakuva(mappinappi0, 100 + 125 * mappivalinta - 35 * kasautuminen, 300);
                                                for(int i=0;i<2;i++) {
                                                        for(int j=0;j<5;j++) {
                                                                if(progressmaara >= i * 5 + j) piirrakuva(mappinappi[j], 850 - 35 * kasautuminen + 125 * j, 200 + 100 * i);
                                                                else piirrakuva(mappinappilock, 850 - 35 * kasautuminen + 125 * j, 200 + 100 * i);
                                                                if(progress[i * 5 + j]) piirrakuva2(mappinappiok, 857 - 35 * kasautuminen + 125 * j, 184 + 100 * i);
                                                        }
                                                }
                                }
                                else {
                                                if(mappivalinta <= 5) piirrakuva(mappinappi0, 25 + 125 * mappivalinta, 200);
                                                else piirrakuva(mappinappi0, -600 + 125 * mappivalinta, 300);
                                                for(int i=0;i<2;i++) {
                                                        for(int j=0;j<5;j++) {
                                                                if(progressmaara >= i * 5 + j) piirrakuva(mappinappi[j], 150 + 125 * j, 200 + 100 * i);
                                                                else piirrakuva(mappinappilock, 150 + 125 * j, 200 + 100 * i);
                                                                if(progress[i * 5 + j]) piirrakuva2(mappinappiok, 157 + 125 * j, 184 + 100 * i);
                                                        }
                                                }
                                }
                                
                                //play ja hiscoret
                                if(kasautuminen < 20) {
                                                if(nappikasautuminen > 10) piirrakuva(nappipelaa[0], 1100 - 35 * kasautuminen, 525);
                                                else piirrakuva(nappipelaa[0], 1100 - 35 * kasautuminen, 625 - 10 * nappikasautuminen);
                                }
                                else if(nappikasautuminen < 10) piirrakuva(nappipelaa[0], 400, 625 - 10 * nappikasautuminen);
                                else if(valinta == 100 && hiiriprewekanappi) piirrakuva(nappipelaa[2], 400, 525);
                                else if(valinta == 100) piirrakuva(nappipelaa[1], 400, 525);
                                else piirrakuva(nappipelaa[0], 400, 525);
                 }
                 else {
                                piirrakuva(nappitakaisin[0], 75, 1375 - 40 * kasautuminen);
                                if(mappivalinta <= 5) piirrakuva(mappinappi0, 25 + 125 * mappivalinta, 200);
                                else piirrakuva(mappinappi0, -600 + 125 * mappivalinta, 300);
                                for(int i=0;i<2;i++) {
                                        for(int j=0;j<5;j++) {
                                                if(progressmaara >= i * 5 + j) piirrakuva(mappinappi[j], 150 + 125 * j, 200 + 100 * i);
                                                else piirrakuva(mappinappilock, 150 + 125 * j, 200 + 100 * i);
                                                if(progress[i * 5 + j]) piirrakuva2(mappinappiok, 157 + 125 * j, 184 + 100 * i);
                                        }
                                }
                                piirrakuva(nappipelaa2, 400, 525);
                 }
                 //loput
                 if(showfpseverywhere == 2) piirraexpluku(fps, 7);
                 piirrakuva2(menutahtain, hiirix - 1, hiiriy - 1);
                 if(kasautuminen < 20 && menuvalinta == 100) piirrakuva2(valkoinenfade, 0, 0); //fade kaiken päälle
                 
                 SDL_Flip(ruutu);
                 
                 //Lopussa tehtävät asiat
                 if(hiiriekanappi) hiiriprewekanappi = true;
                 else hiiriprewekanappi = false;
                 prewvalinta = valinta;
                 
                      if(hoidatapahtumat()) pois2 = true;
                      laskefps();
                 
    //tähän loppuu menun looppi
    }
}
